#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "EM_PubDataWrapper.h"
#include "EM_SubDataWrapper.h"
#include "dpc_em/executable.h"
#include <chrono>
#include <thread>
#include "EM_GeneralWrapper.h"


GeneralWrapper::GeneralWrapper(ara::log::Logger& mainLog) : 
//Provides 
_EM2TRPCLongTargetsInfo_Provide("dpc_em/dpc_em/EM2TRPCLongTargetsInfoPPort" ,mainLog),
_EM2TRPCLongTargetInfo_Provide("dpc_em/dpc_em/EM2TRPCLongTargetInfoPPort" ,mainLog),
_EM2TRPCLongRoadEdgeInfo_Provide("dpc_em/dpc_em/EM2TRPCLongRoadEdgeInfoPPort" ,mainLog),
_EM2TRPCLongLaneMarkerInfo_Provide("dpc_em/dpc_em/EM2TRPCLongLaneMarkerInfoPPort" ,mainLog),
_EM2DMRoadInfo_Provide("dpc_em/dpc_em/EM2DMRoadInfoPPort" ,mainLog),
_EM2DMRMHeader_Provide("dpc_em/dpc_em/EM2DMRMHeaderPPort" ,mainLog),
_EM2DMIndex_Provide("dpc_em/dpc_em/EM2DMIndexPPort" ,mainLog),
_EM2DMCarPosition_Provide("dpc_em/dpc_em/EM2DMCarPositionPPort" ,mainLog),
_EM2DMLane_Provide("dpc_em/dpc_em/EM2DMLanePPort" ,mainLog),
_EM2DMLaneMarker_Provide("dpc_em/dpc_em/EM2DMLaneMarkerPPort" ,mainLog),
_EM2DMObject_Provide("dpc_em/dpc_em/EM2DMObjectPPort" ,mainLog),
_EM2DMRoadEdge_Provide("dpc_em/dpc_em/EM2DMRoadEdgePPort" ,mainLog),
_EM2DMNeighborLane_Provide("dpc_em/dpc_em/EM2DMNeighborLanePPort" ,mainLog),
_EM2DMCorridor_Provide("dpc_em/dpc_em/EM2DMCorridorPPort" ,mainLog),
_EM2DMSamplingPoint_Provide("dpc_em/dpc_em/EM2DMSamplingPointPPort" ,mainLog),
_EM2DMLineColor_Provide("dpc_em/dpc_em/EM2DMLineColorPPort" ,mainLog),
_EM2DMLineType_Provide("dpc_em/dpc_em/EM2DMLineTypePPort" ,mainLog),
_EM2DMObjectLocation_Provide("dpc_em/dpc_em/EM2DMObjectLocationPPort" ,mainLog),
_EM2DMSLPoint_Provide("dpc_em/dpc_em/EM2DMSLPointPPort" ,mainLog),
_EM2DMLaneControl_Provide("dpc_em/dpc_em/EM2DMLaneControlPPort" ,mainLog),
_EM2DMLaneBoundary_Provide("dpc_em/dpc_em/EM2DMLaneBoundaryPPort" ,mainLog),
_EM2DMLineGeometry_Provide("dpc_em/dpc_em/EM2DMLineGeometryPPort" ,mainLog),
_EM2DMRoadEdgeSegment_Provide("dpc_em/dpc_em/EM2DMRoadEdgeSegmentPPort" ,mainLog),
_EM2SMRMSMMessage_Provide("dpc_em/dpc_em/EM2SMRMSMMessagePPort" ,mainLog),
_EM2SMLaneInfo_Provide("dpc_em/dpc_em/EM2SMLaneInfoPPort" ,mainLog),
_EM2SMLeftLine_Provide("dpc_em/dpc_em/EM2SMLeftLinePPort" ,mainLog),
_EM2SMRightLine_Provide("dpc_em/dpc_em/EM2SMRightLinePPort" ,mainLog),
_EM2SMRightRoadEdge_Provide("dpc_em/dpc_em/EM2SMRightRoadEdgePPort" ,mainLog),
_EM2SMLeftRoadEdge_Provide("dpc_em/dpc_em/EM2SMLeftRoadEdgePPort" ,mainLog),
_EM2SMODDInfo_Provide("dpc_em/dpc_em/EM2SMODDInfoPPort" ,mainLog),
_EM2SMRMEgoLftLnegeometry_Provide("dpc_em/dpc_em/EM2SMRMEgoLftLnegeometryPPort" ,mainLog),
_EM2SMRMEgoRgtLnegeometry_Provide("dpc_em/dpc_em/EM2SMRMEgoRgtLnegeometryPPort" ,mainLog),
_EM2SMRMRdEdgeLftgeometry_Provide("dpc_em/dpc_em/EM2SMRMRdEdgeLftgeometryPPort" ,mainLog),
_EM2SMRMRdEdgeRgtgeometry_Provide("dpc_em/dpc_em/EM2SMRMRdEdgeRgtgeometryPPort" ,mainLog),
//Requireds
_SLAM2EMposition_Required("dpc_em/dpc_em/SLAM2EMpositionRPort" ,mainLog),
_SLAM2EMattribute_Required("dpc_em/dpc_em/SLAM2EMattributeRPort" ,mainLog),
_SLAM2EMline_point_Required("dpc_em/dpc_em/SLAM2EMline_pointRPort" ,mainLog),
_SLAM2EMline_Required("dpc_em/dpc_em/SLAM2EMlineRPort" ,mainLog),
_SLAM2EMspeed_limit_Required("dpc_em/dpc_em/SLAM2EMspeed_limitRPort" ,mainLog),
_SLAM2EMtraffic_object_Required("dpc_em/dpc_em/SLAM2EMtraffic_objectRPort" ,mainLog),
_SLAM2EMlane_Required("dpc_em/dpc_em/SLAM2EMlaneRPort" ,mainLog),
_SLAM2EMroad_edge_Required("dpc_em/dpc_em/SLAM2EMroad_edgeRPort" ,mainLog),
_SLAM2EMslam_road_model_Required("dpc_em/dpc_em/SLAM2EMslam_road_modelRPort" ,mainLog),
_Fusion2EMObjects_Required("dpc_em/dpc_em/Fusion2EMObjectsRPort" ,mainLog),
_CAN2EM_Required("dpc_em/dpc_em/CAN2EMRPort" ,mainLog)
{

    //Provides
    // _EM2TRPCLongTargetsInfo_Provide.Init();
    _EM2TRPCLongTargetsInfo_Provide.Init();
    _EM2TRPCLongTargetInfo_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2TRPCLongRoadEdgeInfo_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2TRPCLongLaneMarkerInfo_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMRMHeader_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMRoadInfo_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMIndex_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMCarPosition_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMLane_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMLaneMarker_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMObject_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMRoadEdge_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMNeighborLane_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMCorridor_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMSamplingPoint_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMLineColor_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMLineType_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMObjectLocation_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMSLPoint_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMLaneControl_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMLaneBoundary_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMLineGeometry_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2DMRoadEdgeSegment_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMRMSMMessage_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMLaneInfo_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMLeftLine_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMRightLine_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMRightRoadEdge_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMLeftRoadEdge_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMODDInfo_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMRMEgoLftLnegeometry_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMRMEgoRgtLnegeometry_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMRMRdEdgeLftgeometry_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    _EM2SMRMRdEdgeRgtgeometry_Provide.Init(_EM2TRPCLongTargetsInfo_Provide._skeleton);
    //Require
    
    _SLAM2EMposition_Required.Init();
    _SLAM2EMattribute_Required.Init();
    _SLAM2EMline_point_Required.Init();
    _SLAM2EMline_Required.Init();
    _SLAM2EMspeed_limit_Required.Init();
    _SLAM2EMtraffic_object_Required.Init();
    _SLAM2EMlane_Required.Init();
    _SLAM2EMroad_edge_Required.Init();
    _SLAM2EMslam_road_model_Required.Init();
    _Fusion2EMObjects_Required.Init();
    _CAN2EM_Required.Init();
}

GeneralWrapper::~GeneralWrapper() 
{
    _SLAM2EMposition_Required.Destroy();
    _SLAM2EMattribute_Required.Destroy();
    _SLAM2EMline_point_Required.Destroy();
    _SLAM2EMline_Required.Destroy();
    _SLAM2EMspeed_limit_Required.Destroy();
    _SLAM2EMtraffic_object_Required.Destroy();
    _SLAM2EMlane_Required.Destroy();
    _SLAM2EMroad_edge_Required.Destroy();
    _SLAM2EMslam_road_model_Required.Destroy();
    _Fusion2EMObjects_Required.Destroy();
    _CAN2EM_Required.Destroy();
}

/*
Data filling 
*/
